17a4aad29de19223d9f7f93939d991eb908489da
[WebKit-https.git] / Source / cmake / OptionsGTK.cmake
1 include(GNUInstallDirs)
2 include(VersioningUtils)
3
4 WEBKIT_OPTION_BEGIN()
5 WEBKIT_OPTION_DEFINE(USE_GTK4 "Whether to enable usage of GTK4 instead of GTK3." PUBLIC OFF)
6
7 SET_PROJECT_VERSION(2 29 1)
8
9 if (USE_GTK4)
10     set(WEBKITGTK_API_VERSION 5.0)
11     set(GTK_MINIMUM_VERSION 3.98.4)
12     CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(WEBKIT 0 0 0)
13 else ()
14     set(WEBKITGTK_API_VERSION 4.0)
15     set(GTK_MINIMUM_VERSION 3.22.0)
16     CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(WEBKIT 83 0 46)
17 endif ()
18
19 CALCULATE_LIBRARY_VERSIONS_FROM_LIBTOOL_TRIPLE(JAVASCRIPTCORE 35 1 17)
20
21 # These are shared variables, but we special case their definition so that we can use the
22 # CMAKE_INSTALL_* variables that are populated by the GNUInstallDirs macro.
23 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}" CACHE PATH "Absolute path to library installation directory")
24 set(EXEC_INSTALL_DIR "${CMAKE_INSTALL_FULL_BINDIR}" CACHE PATH "Absolute path to executable installation directory")
25 set(LIBEXEC_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/webkit2gtk-${WEBKITGTK_API_VERSION}" CACHE PATH "Absolute path to install executables executed by the library")
26
27 set(WEBKITGTK_HEADER_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/webkitgtk-${WEBKITGTK_API_VERSION}")
28 set(INTROSPECTION_INSTALL_GIRDIR "${CMAKE_INSTALL_FULL_DATADIR}/gir-1.0")
29 set(INTROSPECTION_INSTALL_TYPELIBDIR "${LIB_INSTALL_DIR}/girepository-1.0")
30
31 set(USER_AGENT_BRANDING "" CACHE STRING "Branding to add to user agent string")
32 if (USER_AGENT_BRANDING)
33     add_definitions(-DUSER_AGENT_BRANDING="${USER_AGENT_BRANDING}")
34 endif ()
35
36 find_package(Cairo 1.14.0 REQUIRED)
37 find_package(Fontconfig 2.8.0 REQUIRED)
38 find_package(Freetype 2.4.2 REQUIRED)
39 find_package(LibGcrypt 1.6.0 REQUIRED)
40 find_package(GLIB 2.44.0 REQUIRED COMPONENTS gio gio-unix gobject gthread gmodule)
41 find_package(GTK ${GTK_MINIMUM_VERSION} REQUIRED OPTIONAL_COMPONENTS unix-print)
42 find_package(HarfBuzz 0.9.18 REQUIRED COMPONENTS ICU)
43 find_package(ICU 60.2 REQUIRED COMPONENTS data i18n uc)
44 find_package(JPEG REQUIRED)
45 find_package(LibSoup 2.54.0 REQUIRED)
46 find_package(LibXml2 2.8.0 REQUIRED)
47 find_package(PNG REQUIRED)
48 find_package(SQLite3 REQUIRED)
49 find_package(Threads REQUIRED)
50 find_package(ZLIB REQUIRED)
51 find_package(ATK 2.16.0 REQUIRED)
52 find_package(WebP REQUIRED COMPONENTS demux)
53 find_package(ATSPI 2.5.3)
54 find_package(EGL)
55 find_package(OpenGL)
56 find_package(OpenGLES2)
57
58 include(GStreamerDefinitions)
59
60 SET_AND_EXPOSE_TO_BUILD(USE_ATK TRUE)
61 SET_AND_EXPOSE_TO_BUILD(USE_CAIRO TRUE)
62 SET_AND_EXPOSE_TO_BUILD(USE_XDGMIME TRUE)
63 SET_AND_EXPOSE_TO_BUILD(USE_GCRYPT TRUE)
64
65 if (WTF_CPU_ARM OR WTF_CPU_MIPS)
66     SET_AND_EXPOSE_TO_BUILD(USE_CAPSTONE ${DEVELOPER_MODE})
67 endif ()
68
69 # For old versions of HarfBuzz that do not expose an API for the OpenType MATH
70 # table, we enable our own code to parse that table.
71 if ("${PC_HARFBUZZ_VERSION}" VERSION_LESS "1.3.3")
72     add_definitions(-DENABLE_OPENTYPE_MATH=1)
73 endif ()
74
75 # Set the default value for ENABLE_GLES2 automatically.
76 # We are not enabling or disabling automatically a feature here, because
77 # the feature is by default always on (ENABLE_GRAPHICS_CONTEXT_GL=ON).
78 # What we select here automatically is if we use OPENGL (ENABLE_GLES2=OFF)
79 # or OPENGLES2 (ENABLE_GLES2=ON) for building the feature.
80 set(ENABLE_GLES2_DEFAULT OFF)
81
82 if (NOT OPENGL_FOUND AND OPENGLES2_FOUND)
83     set(ENABLE_GLES2_DEFAULT ON)
84 endif ()
85
86 # Public options specific to the GTK port. Do not add any options here unless
87 # there is a strong reason we should support changing the value of the option,
88 # and the option is not relevant to any other WebKit ports.
89 WEBKIT_OPTION_DEFINE(ENABLE_GLES2 "Whether to enable OpenGL ES 2.0." PUBLIC ${ENABLE_GLES2_DEFAULT})
90 WEBKIT_OPTION_DEFINE(ENABLE_GTKDOC "Whether or not to use generate gtkdoc." PUBLIC OFF)
91 WEBKIT_OPTION_DEFINE(ENABLE_INTROSPECTION "Whether to enable GObject introspection." PUBLIC ON)
92 WEBKIT_OPTION_DEFINE(ENABLE_GRAPHICS_CONTEXT_GL "Whether to use OpenGL." PUBLIC ON)
93 WEBKIT_OPTION_DEFINE(ENABLE_QUARTZ_TARGET "Whether to enable support for the Quartz windowing target." PUBLIC ${GTK_SUPPORTS_QUARTZ})
94 WEBKIT_OPTION_DEFINE(ENABLE_X11_TARGET "Whether to enable support for the X11 windowing target." PUBLIC ${GTK_SUPPORTS_X11})
95 WEBKIT_OPTION_DEFINE(ENABLE_WAYLAND_TARGET "Whether to enable support for the Wayland windowing target." PUBLIC ${GTK_SUPPORTS_WAYLAND})
96 WEBKIT_OPTION_DEFINE(USE_LIBNOTIFY "Whether to enable the default web notification implementation." PUBLIC ON)
97 WEBKIT_OPTION_DEFINE(USE_LIBHYPHEN "Whether to enable the default automatic hyphenation implementation." PUBLIC ON)
98 WEBKIT_OPTION_DEFINE(USE_LIBSECRET "Whether to enable the persistent credential storage using libsecret." PUBLIC ON)
99 WEBKIT_OPTION_DEFINE(USE_OPENJPEG "Whether to enable support for JPEG2000 images." PUBLIC ON)
100 WEBKIT_OPTION_DEFINE(USE_WOFF2 "Whether to enable support for WOFF2 Web Fonts." PUBLIC ON)
101 WEBKIT_OPTION_DEFINE(USE_WPE_RENDERER "Whether to enable WPE rendering" PUBLIC ON)
102 WEBKIT_OPTION_DEFINE(USE_SYSTEMD "Whether to enable journald logging" PUBLIC ON)
103
104 # Private options specific to the GTK port. Changing these options is
105 # completely unsupported. They are intended for use only by WebKit developers.
106 WEBKIT_OPTION_DEFINE(USE_ANGLE_WEBGL "Whether to use ANGLE as WebGL backend." PRIVATE OFF)
107
108 # FIXME: Can we use cairo-glesv2 to avoid this conflict?
109 WEBKIT_OPTION_CONFLICT(ENABLE_ACCELERATED_2D_CANVAS ENABLE_GLES2)
110
111 WEBKIT_OPTION_DEPEND(ENABLE_3D_TRANSFORMS ENABLE_GRAPHICS_CONTEXT_GL)
112 WEBKIT_OPTION_DEPEND(ENABLE_ACCELERATED_2D_CANVAS ENABLE_GRAPHICS_CONTEXT_GL)
113 WEBKIT_OPTION_DEPEND(ENABLE_ASYNC_SCROLLING ENABLE_GRAPHICS_CONTEXT_GL)
114 WEBKIT_OPTION_DEPEND(ENABLE_GLES2 ENABLE_GRAPHICS_CONTEXT_GL)
115 WEBKIT_OPTION_DEPEND(ENABLE_WEBGL ENABLE_GRAPHICS_CONTEXT_GL)
116 WEBKIT_OPTION_DEPEND(USE_ANGLE_WEBGL ENABLE_WEBGL)
117 WEBKIT_OPTION_DEPEND(USE_WPE_RENDERER ENABLE_GRAPHICS_CONTEXT_GL)
118 WEBKIT_OPTION_DEPEND(USE_WPE_RENDERER ENABLE_WAYLAND_TARGET)
119
120 SET_AND_EXPOSE_TO_BUILD(ENABLE_DEVELOPER_MODE ${DEVELOPER_MODE})
121 if (DEVELOPER_MODE)
122     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MINIBROWSER PUBLIC ON)
123     if (USE_GTK4)
124         WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_API_TESTS PRIVATE OFF)
125     else ()
126         WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_API_TESTS PRIVATE ON)
127     endif ()
128 else ()
129     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MINIBROWSER PUBLIC OFF)
130     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_API_TESTS PRIVATE OFF)
131 endif ()
132
133 if (CMAKE_SYSTEM_NAME MATCHES "Linux")
134     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEMORY_SAMPLER PRIVATE ON)
135     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_USAGE PRIVATE ON)
136 else ()
137     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEMORY_SAMPLER PRIVATE OFF)
138     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_USAGE PRIVATE OFF)
139 endif ()
140
141 if (CMAKE_SYSTEM_NAME MATCHES "Linux" AND NOT EXISTS "/.flatpak-info")
142     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_BUBBLEWRAP_SANDBOX PUBLIC ON)
143 else ()
144     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_BUBBLEWRAP_SANDBOX PUBLIC OFF)
145 endif ()
146
147 # Enable variation fonts when cairo >= 1.16, fontconfig >= 2.13.0, freetype >= 2.9.0 and harfbuzz >= 1.4.2.
148 if (("${PC_CAIRO_VERSION}" VERSION_GREATER "1.16.0" OR "${PC_CAIRO_VERSION}" STREQUAL "1.16.0")
149     AND ("${PC_FONTCONFIG_VERSION}" VERSION_GREATER "2.13.0" OR "${PC_FONTCONFIG_VERSION}" STREQUAL "2.13.0")
150     AND ("${FREETYPE_VERSION_STRING}" VERSION_GREATER "2.9.0" OR "${FREETYPE_VERSION_STRING}" STREQUAL "2.9.0")
151     AND ("${PC_HARFBUZZ_VERSION}" VERSION_GREATER "1.4.2" OR "${PC_HARFBUZZ_VERSION}" STREQUAL "1.4.2"))
152     WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_VARIATION_FONTS PRIVATE ON)
153 endif ()
154
155 # Public options shared with other WebKit ports. Do not add any options here
156 # without approval from a GTK reviewer. There must be strong reason to support
157 # changing the value of the option.
158 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ACCELERATED_2D_CANVAS PUBLIC OFF)
159 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ASYNC_SCROLLING PRIVATE ON)
160 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DRAG_SUPPORT PUBLIC ON)
161 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SPELLCHECK PUBLIC ON)
162 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_TOUCH_EVENTS PUBLIC ON)
163 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEB_CRYPTO PUBLIC ON)
164 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEBDRIVER PUBLIC ON)
165
166 # Private options shared with other WebKit ports. Add options here when
167 # we need a value different from the default defined in WebKitFeatures.cmake.
168 # Changing these options is completely unsupported.
169 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_AUTOCAPITALIZE PRIVATE ON)
170 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CONTENT_EXTENSIONS PRIVATE ON)
171 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_CONIC_GRADIENTS PRIVATE ON)
172 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_PAINTING_API PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
173 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CSS_TYPED_OM PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
174 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_CURSOR_VISIBILITY PRIVATE ON)
175 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DARK_MODE_CSS PRIVATE ON)
176 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DATALIST_ELEMENT PRIVATE ON)
177 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_DOWNLOAD_ATTRIBUTE PRIVATE ON)
178 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_ENCRYPTED_MEDIA PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
179 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_FTPDIR PRIVATE OFF)
180 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_GPU_PROCESS PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
181 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_INPUT_TYPE_COLOR PRIVATE ON)
182 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_LAYOUT_FORMATTING_CONTEXT PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
183 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MEDIA_STREAM PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
184 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MHTML PRIVATE ON)
185 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_MOUSE_CURSOR_SCALE PRIVATE ON)
186 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_NETWORK_CACHE_SPECULATIVE_REVALIDATION PRIVATE ON)
187 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_NETWORK_CACHE_STALE_WHILE_REVALIDATE PRIVATE ON)
188 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_OFFSCREEN_CANVAS PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
189 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_PERIODIC_MEMORY_MONITOR PRIVATE ON)
190 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_POINTER_LOCK PRIVATE ON)
191 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_RESOURCE_LOAD_STATISTICS PRIVATE ON)
192 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SERVICE_WORKER PRIVATE ON)
193 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_SHAREABLE_RESOURCE PUBLIC ON)
194 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_WEB_RTC PRIVATE ${ENABLE_EXPERIMENTAL_FEATURES})
195
196 if (USE_GTK4)
197 WEBKIT_OPTION_DEFAULT_PORT_VALUE(ENABLE_NETSCAPE_PLUGIN_API PRIVATE OFF)
198 endif ()
199
200 include(GStreamerDependencies)
201
202 # Finalize the value for all options. Do not attempt to use an option before
203 # this point, and do not attempt to change any option after this point.
204 WEBKIT_OPTION_END()
205
206 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_QUARTZ ${ENABLE_QUARTZ_TARGET})
207 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_X11 ${ENABLE_X11_TARGET})
208 SET_AND_EXPOSE_TO_BUILD(WTF_PLATFORM_WAYLAND ${ENABLE_WAYLAND_TARGET})
209
210 if (ENABLE_NETSCAPE_PLUGIN_API)
211     # MOZ_X11 and XP_UNIX are required by npapi.h. Their value is not checked;
212     # only their definedness is. They should only be defined in the true case.
213     if (ENABLE_X11_TARGET)
214         SET_AND_EXPOSE_TO_BUILD(MOZ_X11 1)
215     endif ()
216     SET_AND_EXPOSE_TO_BUILD(XP_UNIX 1)
217 endif ()
218
219 SET_AND_EXPOSE_TO_BUILD(ENABLE_PLUGIN_PROCESS ${ENABLE_NETSCAPE_PLUGIN_API})
220
221 add_definitions(-DBUILDING_GTK__=1)
222 add_definitions(-DGETTEXT_PACKAGE="WebKit2GTK-${WEBKITGTK_API_VERSION}")
223 add_definitions(-DWEBKITGTK_API_VERSION_STRING="${WEBKITGTK_API_VERSION}")
224 add_definitions(-DJSC_GLIB_API_ENABLED)
225
226 if (EXISTS "${TOOLS_DIR}/glib/svn-revision")
227     execute_process(COMMAND ${TOOLS_DIR}/glib/svn-revision ERROR_QUIET OUTPUT_VARIABLE SVN_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE)
228 else ()
229     set(SVN_REVISION "tarball")
230 endif ()
231 add_definitions(-DSVN_REVISION="${SVN_REVISION}")
232
233 SET_AND_EXPOSE_TO_BUILD(HAVE_GTK_UNIX_PRINTING ${GTK_UNIX_PRINT_FOUND})
234
235 if (USE_WPE_RENDERER)
236     find_package(WPE 1.3.0)
237     if (NOT WPE_FOUND)
238         message(FATAL_ERROR "libwpe is required for USE_WPE_RENDERER")
239     endif ()
240
241     find_package(WPEBackend_fdo 1.3.1)
242     if (NOT WPEBACKEND_FDO_FOUND)
243         message(FATAL_ERROR "WPEBackend-fdo is required for USE_WPE_RENDERER")
244     endif ()
245 endif ()
246
247 if (ENABLE_XSLT)
248     find_package(LibXslt 1.1.7 REQUIRED)
249 endif ()
250
251 if (ENABLE_ACCELERATED_2D_CANVAS)
252     if (GLX_FOUND)
253         list(APPEND CAIROGL_COMPONENTS cairo-glx)
254     endif ()
255     if (EGL_FOUND)
256         list(APPEND CAIROGL_COMPONENTS cairo-egl)
257     endif ()
258
259     find_package(CairoGL 1.10.2 COMPONENTS ${CAIROGL_COMPONENTS})
260     if (NOT CAIROGL_FOUND)
261         message(FATAL_ERROR "CairoGL is needed for ENABLE_ACCELERATED_2D_CANVAS")
262     endif ()
263 endif ()
264
265 if (USE_LIBSECRET)
266     find_package(Libsecret)
267     if (NOT LIBSECRET_FOUND)
268         message(FATAL_ERROR "libsecret is needed for USE_LIBSECRET")
269     endif ()
270 endif ()
271
272 if (USE_GTK4)
273     set(ENABLE_INTROSPECTION OFF)
274 endif ()
275
276 if (ENABLE_INTROSPECTION)
277     find_package(GObjectIntrospection)
278     if (NOT INTROSPECTION_FOUND)
279         message(FATAL_ERROR "GObjectIntrospection is needed for ENABLE_INTROSPECTION.")
280     endif ()
281 endif ()
282
283 if (ENABLE_WEB_CRYPTO)
284     find_package(Libtasn1 REQUIRED)
285     if (NOT LIBTASN1_FOUND)
286         message(FATAL_ERROR "libtasn1 is required to enable Web Crypto API support.")
287     endif ()
288     if (LIBGCRYPT_VERSION VERSION_LESS 1.7.0)
289         message(FATAL_ERROR "libgcrypt 1.7.0 is required to enable Web Crypto API support.")
290     endif ()
291 endif ()
292
293 if (ENABLE_WEBDRIVER)
294     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_KEYBOARD_INTERACTIONS ON)
295     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_MOUSE_INTERACTIONS ON)
296     SET_AND_EXPOSE_TO_BUILD(ENABLE_WEBDRIVER_TOUCH_INTERACTIONS OFF)
297 endif ()
298
299 SET_AND_EXPOSE_TO_BUILD(USE_TEXTURE_MAPPER TRUE)
300
301 if (ENABLE_GRAPHICS_CONTEXT_GL)
302     # ENABLE_GRAPHICS_CONTEXT_GL is true if either USE_OPENGL or ENABLE_GLES2 is true.
303     # But USE_OPENGL is the opposite of ENABLE_GLES2.
304     if (ENABLE_GLES2)
305         find_package(OpenGLES2 REQUIRED)
306         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL_ES TRUE)
307         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL FALSE)
308
309         if (NOT EGL_FOUND)
310             message(FATAL_ERROR "EGL is needed for ENABLE_GLES2.")
311         endif ()
312     else ()
313         if (NOT OPENGL_FOUND)
314             message(FATAL_ERROR "Either OpenGL or OpenGLES2 is needed for ENABLE_GRAPHICS_CONTEXT_GL.")
315         endif ()
316         SET_AND_EXPOSE_TO_BUILD(USE_OPENGL TRUE)
317     endif ()
318
319     if (NOT EGL_FOUND AND (NOT ENABLE_X11_TARGET OR NOT GLX_FOUND))
320         message(FATAL_ERROR "Either GLX or EGL is needed for ENABLE_GRAPHICS_CONTEXT_GL.")
321     endif ()
322
323     SET_AND_EXPOSE_TO_BUILD(ENABLE_GRAPHICS_CONTEXT_GL TRUE)
324
325     SET_AND_EXPOSE_TO_BUILD(USE_TEXTURE_MAPPER_GL TRUE)
326
327     SET_AND_EXPOSE_TO_BUILD(USE_EGL ${EGL_FOUND})
328
329     if (ENABLE_X11_TARGET AND GLX_FOUND AND USE_OPENGL)
330         SET_AND_EXPOSE_TO_BUILD(USE_GLX TRUE)
331     endif ()
332
333     SET_AND_EXPOSE_TO_BUILD(USE_COORDINATED_GRAPHICS TRUE)
334     SET_AND_EXPOSE_TO_BUILD(USE_NICOSIA TRUE)
335 endif ()
336
337 if (USE_ANGLE_WEBGL)
338     SET_AND_EXPOSE_TO_BUILD(USE_ANGLE TRUE)
339     SET_AND_EXPOSE_TO_BUILD(USE_ANGLE_EGL TRUE)
340 endif ()
341
342 if (ENABLE_SPELLCHECK)
343     find_package(Enchant)
344     if (NOT PC_ENCHANT_FOUND)
345         message(FATAL_ERROR "Enchant is needed for ENABLE_SPELLCHECK")
346     endif ()
347 endif ()
348
349 if (ENABLE_QUARTZ_TARGET)
350     if (NOT GTK_SUPPORTS_QUARTZ)
351         message(FATAL_ERROR "Recompile GTK with Quartz backend to use ENABLE_QUARTZ_TARGET")
352     endif ()
353 endif ()
354
355 if (ENABLE_X11_TARGET)
356     if (NOT GTK_SUPPORTS_X11)
357         message(FATAL_ERROR "Recompile GTK with X11 backend to use ENABLE_X11_TARGET")
358     endif ()
359
360     find_package(X11 REQUIRED)
361     if (NOT X11_Xcomposite_FOUND)
362         message(FATAL_ERROR "libXcomposite is required for ENABLE_X11_TARGET")
363     elseif (NOT X11_Xdamage_FOUND)
364         message(FATAL_ERROR "libXdamage is required for ENABLE_X11_TARGET")
365     elseif (NOT X11_Xrender_FOUND)
366         message(FATAL_ERROR "libXrender is required for ENABLE_X11_TARGET")
367     elseif (NOT X11_Xt_FOUND)
368         message(FATAL_ERROR "libXt is required for ENABLE_X11_TARGET")
369     endif ()
370 endif ()
371
372 if (ENABLE_WAYLAND_TARGET)
373     if (NOT GTK_SUPPORTS_WAYLAND)
374         message(FATAL_ERROR "Recompile GTK with Wayland backend to use ENABLE_WAYLAND_TARGET")
375     endif ()
376
377     if (NOT EGL_FOUND)
378         message(FATAL_ERROR "EGL is required to use ENABLE_WAYLAND_TARGET")
379     endif ()
380
381     find_package(Wayland REQUIRED)
382     find_package(WaylandProtocols 1.12 REQUIRED)
383 endif ()
384
385 if (USE_LIBNOTIFY)
386     find_package(LibNotify)
387     if (NOT LIBNOTIFY_FOUND)
388        message(FATAL_ERROR "libnotify is needed for USE_LIBNOTIFY.")
389     endif ()
390 endif ()
391
392 if (USE_LIBHYPHEN)
393     find_package(Hyphen)
394     if (NOT HYPHEN_FOUND)
395        message(FATAL_ERROR "libhyphen is needed for USE_LIBHYPHEN.")
396     endif ()
397 endif ()
398
399 if (USE_OPENJPEG)
400     find_package(OpenJPEG 2.2.0)
401     if (NOT OpenJPEG_FOUND)
402         message(FATAL_ERROR "libopenjpeg 2.2.0 is required for USE_OPENJPEG.")
403     endif ()
404 endif ()
405
406 if (USE_WOFF2)
407     find_package(WOFF2Dec 1.0.2)
408     if (NOT WOFF2DEC_FOUND)
409        message(FATAL_ERROR "libwoff2dec is needed for USE_WOFF2.")
410     endif ()
411 endif ()
412
413 if (USE_SYSTEMD)
414     find_package(Systemd)
415     if (Systemd_FOUND)
416         message(STATUS "Release logs will be sent to the Systemd journal")
417         SET_AND_EXPOSE_TO_BUILD(USE_JOURNALD TRUE)
418     else ()
419         message(FATAL_ERROR "libsystemd is needed for USE_SYSTEMD")
420     endif ()
421 endif ()
422
423 # https://bugs.webkit.org/show_bug.cgi?id=182247
424 if (ENABLED_COMPILER_SANITIZERS)
425     set(ENABLE_INTROSPECTION OFF)
426 endif ()
427
428 # Override the cached variable, gtk-doc does not really work when building on Mac.
429 if (APPLE)
430     set(ENABLE_GTKDOC OFF)
431 endif ()
432
433 set(DERIVED_SOURCES_WEBKITGTK_DIR ${DERIVED_SOURCES_DIR}/webkitgtk)
434 set(DERIVED_SOURCES_WEBKITGTK_API_DIR ${DERIVED_SOURCES_WEBKITGTK_DIR}/webkit)
435 set(DERIVED_SOURCES_WEBKIT2GTK_DIR ${DERIVED_SOURCES_DIR}/webkit2gtk)
436 set(DERIVED_SOURCES_WEBKIT2GTK_API_DIR ${DERIVED_SOURCES_WEBKIT2GTK_DIR}/webkit2)
437 set(DERIVED_SOURCES_JAVASCRIPCOREGTK_DIR ${DERIVED_SOURCES_JAVASCRIPTCORE_DIR}/javascriptcoregtk)
438 set(DERIVED_SOURCES_JAVASCRIPCORE_GLIB_API_DIR ${DERIVED_SOURCES_JAVASCRIPTCORE_DIR}/javascriptcoregtk/jsc)
439 set(FORWARDING_HEADERS_WEBKIT2GTK_DIR ${FORWARDING_HEADERS_DIR}/webkit2gtk)
440 set(FORWARDING_HEADERS_WEBKIT2GTK_VERSIONED_DIR ${FORWARDING_HEADERS_DIR}/webkit2gtk-${WEBKITGTK_API_VERSION})
441 set(FORWARDING_HEADERS_WEBKIT2GTK_EXTENSION_DIR ${FORWARDING_HEADERS_DIR}/webkit2gtk-webextension)
442
443 set(JavaScriptCore_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/JavaScriptCore/javascriptcoregtk-${WEBKITGTK_API_VERSION}.pc)
444 set(WebKit2_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/WebKit/webkit2gtk-${WEBKITGTK_API_VERSION}.pc)
445 set(WebKit2WebExtension_PKGCONFIG_FILE ${CMAKE_BINARY_DIR}/Source/WebKit/webkit2gtk-web-extension-${WEBKITGTK_API_VERSION}.pc)
446
447 set(JavaScriptCore_LIBRARY_TYPE SHARED)
448 set(SHOULD_INSTALL_JS_SHELL ON)
449
450 # Add a typelib file to the list of all typelib dependencies. This makes it easy to
451 # expose a 'gir' target with all gobject-introspection files.
452 macro(ADD_TYPELIB typelib)
453     if (ENABLE_INTROSPECTION)
454         get_filename_component(target_name ${typelib} NAME_WE)
455         add_custom_target(${target_name}-gir ALL DEPENDS ${typelib})
456         list(APPEND GObjectIntrospectionTargets ${target_name}-gir)
457         set(GObjectIntrospectionTargets ${GObjectIntrospectionTargets} PARENT_SCOPE)
458     endif ()
459 endmacro()
460
461 # CMake does not automatically add --whole-archive when building shared objects from
462 # a list of convenience libraries. This can lead to missing symbols in the final output.
463 # We add --whole-archive to all libraries manually to prevent the linker from trimming
464 # symbols that we actually need later. With ld64 on darwin, we use -all_load instead.
465 macro(ADD_WHOLE_ARCHIVE_TO_LIBRARIES _list_name)
466     if (CMAKE_SYSTEM_NAME MATCHES "Darwin")
467         list(APPEND ${_list_name} -Wl,-all_load)
468     else ()
469         set(_tmp)
470         foreach (item IN LISTS ${_list_name})
471             if ("${item}" STREQUAL "PRIVATE" OR "${item}" STREQUAL "PUBLIC")
472                 list(APPEND _tmp "${item}")
473             else ()
474                 list(APPEND _tmp -Wl,--whole-archive "${item}" -Wl,--no-whole-archive)
475             endif ()
476         endforeach ()
477         set(${_list_name} ${_tmp})
478     endif ()
479 endmacro()
480
481 include(BubblewrapSandboxChecks)
482 include(GStreamerChecks)